<form method="post" action="compiler5.php">
<textarea name="compilerinput" rows="64" cols="64">
$e+$d[1][1+1+1]+$ab+$c
</textarea>
<input type="submit" value="compile">
</form>


<?php
$lexstream = $_POST ["compilerinput"]; 
$lexstreami = 0;
str_replace ("\n", " ", $lexstream);
str_replace ("\t", " ", $lexstream);
str_replace ("\r", " ", $lexstream);
$global_vars ["ab"] = 1;
$global_vars ["c"] = 2;
$global_vars ["d13"] = 0.4;
$global_vars ["e"] = 4;
echo numexpr ();


function is_illegal_sign () {
    global $lexstream;
    global $lexstreami;
    
    if (strcmp (substr ($lexstream, $lexstreami, 1), "@") == 0)
        return true;
    else if (strcmp (substr ($lexstream, $lexstreami, 1), "&") == 0)
        return true;
    return false;
    /* ... */
}

function is_not_float_sign () {
    global $lexstreami;
    global $lexstream;
    
    $ch = substr ($lexstream, $lexstreami, 1);
    
    if ((strcmp ($ch, "0") >= 0) && (strcmp ($ch, "9") <= 0)) {
        return false;
    }
    if (strcmp ($ch, ".") != 0) {
        if (strcmp ($ch, "e") != 0) {
            if (strcmp ($ch, "E") != 0) {
                if (strcmp ($ch, "_") != 0) {
                    return true;
                }
                return false;
            }
            return false;
        }
        return false;
    }
    return false;
}

function charstrval () {
    global $lexstreami;
    global $lexstream;
    $retstr = "";
    
    for ($i = 0;  (strcasecmp (substr ($lexstream, $lexstreami+$i, 1), "a") >= 0) && 
                (strcasecmp (substr ($lexstream, $lexstreami+$i, 1), "z") <= 0) &&
                (($lexstreami+$i) < strlen ($lexstream));  $i++)
        $retstr = $retstr . substr ($lexstream, $lexstreami+$i, 1);
return $retstr;
}

function lexer () {
    global $lexstreami;
    global $lexstream;
    
    if ((strcmp( $retstr = lexer2 (), "NOSIGN")) != 0) 
        return $retstr;
    else if ((($retflt = floatval (substr ($lexstream, $lexstreami, strlen ($lexstream) - $lexstreami))) != 0) || 
            (strcmp (substr ($lexstream, $lexstreami, 1), "0") == 0)) {
        while (true) {
            if (strcmp( lexer3 (), "ILLEGALSIGN") == 0) {
                break;
            }
            if (strcmp( $tmpretstr1 = lexer3 (), "NOSIGN") != 0) {
                if (is_not_float_sign ()) {
                    break;
                }
                if (strcmp ($tmprestr1, "CODEENDS") == 0)
                    break;
            }
            if (is_not_float_sign ()) {
                break;
            }
            $lexstreami++;
        }

        return $retflt;
    }
    else if (strcmp($retstr = charstrval (substr ($lexstream, $lexstreami, strlen ($lexstream) - $lexstreami)), "") != 0) {
        $lexstreami += strlen ($retstr);
        return $retstr;
    }
    else {
        $lexstreami++;
        return $retstr;
    }

}


function lexer3 () {
    global $lexstreami;
    global $lexstream;
    
    if ($lexstreami == strlen ($lexstream)) {
        return "CODEENDS";
    }
    if (strcmp(substr ($lexstream, $lexstreami, 1), '+') == 0) {
        return "+";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '-') == 0) {
        return "-";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '*') == 0) {
        return "*";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '/') == 0) {
        return "/";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '%') == 0) {
        return "%";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ';') == 0) {
        return ";";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '(') == 0) {
        return "(";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ')') == 0) {
        return ")";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '[') == 0) {
        return "[";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ']') == 0) {
        return "]";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '$') == 0) {
        return "$";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '<') == 0) {
        if (strcmp(substr ($lexstream, $lexstreami+1, 1), '=') == 0) {
            return "<=";
        }
        return "<";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '>') == 0) {
        if (strcmp(substr ($lexstream, $lexstreami+1, 1), '=') == 0) {
            return ">=";
        }
        return ">";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
        if (strcmp(substr ($lexstream, $lexstreami+1, 1), '=') == 0) {
            return "==";
        }
        return "=";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ':') == 0) {
        if (strcmp(substr ($lexstream, $lexstreami+1, 1), '=') == 0) {
            return ":=";
        }
        else
            return "NOSIGN";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '!') == 0) {
        if (strcmp(substr ($lexstream, $lexstreami+1, 1), '=') == 0) {
            return "!=";
        }
        return "!";
    }
    else if (is_illegal_sign()) {
        return "ILLEGALSIGN";
    }
    else {
        return "NOSIGN";
    }
}



function lexer2 () {
    global $lexstreami;
    global $lexstream;
    
    if ($lexstreami == strlen ($lexstream)) {
        return "CODEENDS";
    }
    if (strcmp(substr ($lexstream, $lexstreami, 1), '+') == 0) {
        $lexstreami++;
        return "+";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '-') == 0) {
        $lexstreami++;
        return "-";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '*') == 0) {
        $lexstreami++;
        return "*";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '/') == 0) {
        $lexstreami++;
        return "/";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '%') == 0) {
        $lexstreami++;
        return "%";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ';') == 0) {
        $lexstreami++;
        return ";";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '(') == 0) {
        $lexstreami++;
        return "(";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ')') == 0) {
        $lexstreami++;
        return ")";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '[') == 0) {
        $lexstreami++;
        return "[";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ']') == 0) {
        $lexstreami++;
        return "]";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '$') == 0) {
        $lexstreami++;
        return "$";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '<') == 0) {
        $lexstreami++;
        if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
            $lexstreami++;
            return "<=";
        }
        return "<";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '>') == 0) {
        $lexstreami++;
        if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
            $lexstreami++;
            return ">=";
        }
        return ">";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
        $lexstreami++;
        if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
            $lexstreami++;
            return "==";
        }
        return "=";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ':') == 0) {
        $lexstreami++;
        if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
            $lexstreami++;
            return ":=";
        }
        else
            return "NOSIGN";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), '!') == 0) {
        $lexstreami++;
        if (strcmp(substr ($lexstream, $lexstreami, 1), '=') == 0) {
            $lexstreami++;
            return "!=";
        }
        return "!";
    }
    else if (strcmp(substr ($lexstream, $lexstreami, 1), ' ') == 0) {
        $lexstreami++;
        return lexer ();
    }
    else if (is_illegal_sign()) {
        return "ILLEGALSIGN";
    }
    else {
        return "NOSIGN";
    }
}


function numexpr () {
    $x = term ();
    $y = numexpr2 ();
    return $x+$y;
}

function numexpr2 () {
    global $lexstreami;
    $lexstreamitmp = $lexstreami;
    if (strcmp (lexer (), "+") == 0) {
        $x = term ();
        $y = numexpr2 ();
        return $x+$y;
    }
    $lexstreami = $lexstreamitmp;
    return 0;
}

function term () {
    $x = factor ();
    $y = term2 ();
    return $x*$y;
}

function term2 () {
    global $lexstreami;
    $lexstreamitmp = $lexstreami;
    if (strcmp (lexer (), "*") == 0) {
        $x = factor ();
        $y = term2 ();
        return $x*$y;
    }
    $lexstreami = $lexstreamitmp;
    return 1;
}

function factor () {
    global $global_vars;
    $retval = lexer ();
    
    if (strcmp (gettype ($retval), "double") == 0) {
        echo $retval . "<br>";
        return $retval;
    }
    else if (strcmp ($retval, '(') == 0) {
        $retval = numexpr ();
        if (strcmp (lexer (), ")") != 0) 
            exit ("Forget round bracket in arithmetic expression");
        return $retval;
    }
    else if (strcmp ($retval, '$') == 0) {
        $lx = lexer ();
        if ((strcasecmp (substr($lx, 0, 1), "a") >= 0) && (strcasecmp (substr($lx, 0, 1), "z") <= 0)) {
            $arraynamestr = arrayname ();
            return $global_vars [$lx . $arraynamestr];
        }
        else 
            exit ("bad variable name");
    }
    else {
        exit ("error in arithmetic expression");
    }
}

function arrayname () {
    global $lexstreami;
    global $lexstream;
    $lexstreamitmp = $lexstreami;
    
    if (strcmp (lexer (), "[") == 0) {
        $arrayindexstr = strval (numexpr());
        if (strcmp (lexer (), "]") != 0) 
            exit ("Forgot closing array bracket");
        $lexstreamitmp2 = $lexstreami;
        if (strcmp (lexer (), "[") == 0) {
            $lexstreami = $lexstreamitmp2;
            $arrayindexstr = $arrayindexstr . arrayname ();
        }
        else
            $lexstreami = $lexstreamitmp2;
        return $arrayindexstr;    
    }
    $lexstreami = $lexstreamitmp;
    return "";
}

function boolexpr () {
    $x = num_expr ();
    $cop = lexer ();
    $y = num_expr ();
    if (strcmp ($cop, "<") == 0)
        return ($x < $y);
    else if (strcmp ($cop, ">") == 0)
        return ($x > $y);
    else if (strcmp ($cop, "<=") == 0)
        return ($x <= $y);
    else if (strcmp ($cop, ">=") == 0)
        return ($x >= $y);
    else if (strcmp ($cop, "<=") == 0);
        return ($x <= $y);
    else if (strcmp ($cop, "!=") == 0);
        return ($x != $y);
    else if (strcmp ($cop, "==") == 0);
        return ($x == $y);
    else
        exit ("Wrong compare operator in boolesche expression");

}

function block () {
    global $lexstreami;
    global $lexstream;
    $lexstreamitmp = $lexstreami;
    
    if (strcasecmp (lexer (), "begin")) {
        statement ();
        if (strcasecmp (lexer (), "end"));
        else 
            exit ("forgot end in block");
    }
    else {
        $lexstreami = $lexstreamitmp;
        statement ();
    }
}

function loop () {
    global $lexstreami;
    global $lexstream;
    $lexstreamitmp = $lexstreami;
    
    if (strcasecmp (lexer (), "while") {
        if (boolexpr ()) {
            if (strcasecmp (lexer (), "do") {
                block ();
            }
            else 
                exit ("Forgot do in while statement");
        }
        else 
            block_do_not_execute ();
    }
    else 
        $lexstreami = $lexstreamitmp;
    
}

?>
